#!/bin/sh
# the next line restarts using wishx \
exec tclx "$0" "$@"

# this is MB_ISDNmonp_consoleclient.tcl
# Modifications Copyright 1999 by Manuel Bessler
# modified by MB to support client server
# for the server part look for MB_ISDNmonp_server.tcl
#


set infohost 192.168.1.11
set infoport 800


proc bgerror {mesg} {
    global errorInfo errorCode
    if {$errorCode == "POSIX EPIPE {broken pipe}"} then {
        puts "Connection to server lost. Giving up"
	exit	
    } else {
	puts "Unkown error occurred:"
        puts "-----error message:-----\n$mesg\n-----errorInfo:-----\n$errorInfo\n-----errorCode:-----\n$errorCode\n----------"
	exit
    }
    exit
}

proc down {} {
  global sock 
  puts $sock "DOWN" 
}


proc read_sock {sock1} {
  set l [gets $sock1]
  if {$l != ""} then {
     switch -regexp $l {
	^5[.]*	{#error
puts "MB_ISDNmonp_client.tcl: error 5??,\n server returned: $l"
		miscerror
		}
	^301[.]*	{#shutdown
		}
	default {#unkown command
puts "MB_ISDNmonp_client.tcl: server returned: $l"
		miscerror
		}
     }	
  }
}

proc init {} {
	global sock infohost infoport

	set sockopenok [catch {set sock [socket $infohost $infoport]}]
	if {$sockopenok != 0} then {
	    puts stderr "Open socket failed: Is the server running?"
	    exit
	}
	fileevent $sock readable "read_sock $sock"
	fconfigure $sock -buffering line
}



proc main {} {
global sock
init
after 500
update idletasks
down
update idletasks
after 1000
close $sock
update idletasks
}

main






